/*
  mcore.h - Micro Core Libraries for Embedded System

  Copyright (c) 2022 Sasapea's Lab. All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General
  Public License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/
#pragma once

#include "task.h"
#include "fifo.h"
#include "led.h"
#include "alarm.h"
#include "hardware.h"

/* Board Library Include */
#ifndef BOARD_NAME
  #if   defined(ARDUINO_AVR_UNO) || \
        defined(ARDUINO_AVR_DUEMILANOVE) || \
        defined(ARDUINO_AVR_LILYPAD) || \
        defined(ARDUINO_AVR_NG) || \
        defined(ARDUINO_AVR_UNO_WIFI_DEV_ED)
    #define BOARD_NAME standard
  #elif defined(ARDUINO_AVR_LEONARDO) || \
        defined(ARDUINO_AVR_LEONARDO_ETH) || \
        defined(ARDUINO_AVR_ESPLORA) || \
        defined(ARDUINO_AVR_LILYPAD_USB) || \
        defined(ARDUINO_AVR_A_STAR_32U4)
    #define BOARD_NAME leonardo
  #elif defined(ARDUINO_AVR_MICRO)
    #define BOARD_NAME micro
  #elif defined(ARDUINO_AVR_DIGISPARK)
    #define BOARD_NAME digispark
  #else
    #define BOARD_NAME none
  #endif
#endif

#define  STRINGIFY(str)   #str
#define  EXPANDSTR(x)     STRINGIFY(x)
#define  EXPAND1(x)       x
#define  EXPAND2(x, y)    EXPAND1(x)y
#define  EXPAND3(x, y, z) EXPAND2(x, y)z
#undef   INCLUDE_NAME
#define  INCLUDE_NAME     EXPANDSTR(EXPAND3(mcore_,BOARD_NAME,.h))
#include INCLUDE_NAME
