/*
  mcore_none.h - Board Library

  Copyright (c) 2022 Sasapea's Lab. All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General
  Public License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/
#pragma once

#include "task.h"
#include "led.h"
#include "alarm.h"

#define LED_R 0
#define LED_G 1

class MCore
{
  public:

    static
    void begin(void)
    {
      AlarmTimer.begin();
      Task::begin();
      /* Setup LEDs */
      Led::begin();
    }

    static
    void handle(void)
    {
      Led::handle();
      Task::yield();
    }
};
